文章标题 HDU 1969 : Pie(二分)

来源:互联网 发布:辐射4材质优化mod 编辑:程序博客网 时间:2024/05/13 20:38

Pie

Description
My birthday is coming up and traditionally I’m serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
Input
One line with a positive integer: the number of test cases. Then for each test case:
—One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
—One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
Output
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
Sample Input
3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2
Sample Output
25.1327
3.1416
50.2655
题意:我过生日,然后请朋友吃蛋糕,然后有n个蛋糕,每个蛋糕的直径为ri,有f个朋友,现要将这些蛋糕分给f个朋友和自己,要求每块蛋糕是完整的一块,且每个人的蛋糕的大小一样,假定每个蛋糕的高度都为1,现要求出每个人能分到的最大的蛋糕是多大
分析:由题意可知,每个人能分到的蛋糕肯定在0~max(最大蛋糕的体积)之间,所以用二分法,然后分别求出每个蛋糕能分成多少块mid大小的蛋糕,如果所有的蛋糕能分成的数目大于f+1,说明此时的蛋糕还能再大,否则说明应该减小
代码:

#include<iostream>#include<string>#include<cstdio>#include<cstring>#include<vector>#include<math.h>#include<map>#include<queue> #include<algorithm>using namespace std;const int inf = 0x3f3f3f3f;int n,f; double pie[10005];//保存每块蛋糕的体积const double pi = acos(-1.0);int main (){    int t;    scanf ("%d",&t);    while (t--){        scanf ("%d%d",&n,&f);        f++;        double maxn=0;        double r;        for (int i=0;i<n;i++){            scanf ("%lf",&pie[i]);            maxn=max(maxn,pie[i]*pie[i]*pi);//求最大的蛋糕的体积,及上限        }        double lo=0,hi=maxn;        double mid;        while (fabs(hi-lo)>1e-7){            mid=(hi+lo)/2;            int cnt=0;            for (int i=0;i<n;i++){//计算n个蛋糕能分成多少块mid大小的蛋糕                cnt+=(int)(pie[i]*pie[i]*pi/mid);            }            if (cnt>=f){//说明还能再大点                lo=mid;            }            else hi=mid;        }        printf ("%.4f\n",mid);    }     return 0;}
0 0
原创粉丝点击